% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function varargout = FDMCusum(varargin)
% FDMCUSUM M-file for FDMCusum.fig
%      FDMCUSUM, by itself, creates a new FDMCUSUM or raises the existing
%      singleton*.
%
%      H = FDMCUSUM returns the handle to a new FDMCUSUM or the handle to
%      the existing singleton*.
%
%      FDMCUSUM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FDMCUSUM.M with the given input arguments.
%
%      FDMCUSUM('Property','Value',...) creates a new FDMCUSUM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FDMCusum_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FDMCusum_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FDMCusum

% Last Modified by GUIDE v2.5 10-Feb-2015 06:16:23

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FDMCusum_OpeningFcn, ...
                   'gui_OutputFcn',  @FDMCusum_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FDMCusum is made visible.
function FDMCusum_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FDMCusum (see VARARGIN)

% Choose default command line output for start2
handles.output = hObject;

contents = cellstr(get(handles.popupmenu2,'String'));
model.selected_val = contents{get(handles.popupmenu2,'Value')};


model.my_n = 100;
model.my_m = 100;


switch model.selected_val
    case 'rectangle'
        model.my_shape = get_shape(model.my_n, model.my_m,  model.selected_val);
    case 'diamond'
        model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
    case 'round'
        model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
    case 'roundcorner'
        model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
    otherwise
end

all_settings.model = model;
all_settings.estimation.dummy = 0;
all_settings.weights.dummy = 0;
all_settings.results.dummy = 0;

handles.all_settings = all_settings;

handles = define_panels(handles);
handles.k=1;
show_panels(handles);

% DISPLAY THE CHANGE SET
axes(handles.axes2);
imagesc(model.my_shape);
set(gca,'YDir','normal')

% Update handles structure
guidata(hObject, handles);


% UIWAIT makes FDMCusum wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FDMCusum_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = scan_panels(handles,'H');
   
% Update handles structure
guidata(hObject, handles);
   
   
% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = scan_panels(handles,'V');
   
% Update handles structure
guidata(hObject, handles);

% --- Executes on selection change in popupmenu2.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on pushbutton1 and none of its controls.
function pushbutton1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on slider movement.
function slider_numcon_Callback(hObject, eventdata, handles)
% hObject    handle to slider_numcon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider



% --- Executes during object creation, after setting all properties.
function slider_numcon_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_numcon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pushbutton1.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = scan_panels(handles,'VH');
   
% Update handles structure
guidata(hObject, handles);

% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2

contents = cellstr(get(handles.popupmenu2,'String'));
model.selected_val = contents{get(handles.popupmenu2,'Value')};


model.my_n = str2num(get(handles.txt_n,'string'));
model.my_m = str2num(get(handles.txt_m,'string'));

switch model.selected_val
    case 'rectangle'
        model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
    case 'diamond'
        model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
    case 'round'
        model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
    case 'roundcorner'
        model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
    otherwise
end

all_settings.model = model;
all_settings.estimation.dummy = 0;
all_settings.weights.dummy = 0;
all_settings.results.dummy = 0;

handles.all_settings = all_settings;

% DISPLAY THE CHANGE SET
axes(handles.axes2);
imagesc(model.my_shape);
set(gca,'YDir','normal')
    
handles = define_panels(handles);
show_panels(handles);

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on key press with focus on popupmenu2 and none of its controls.
function popupmenu2_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



function txt_noise_Callback(hObject, eventdata, handles)
% hObject    handle to txt_noise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_noise as text
%        str2double(get(hObject,'String')) returns contents of txt_noise as a double
% 
% handles.my_sigma2 = str2num(get(handles.txt_noise,'string'));
% 
% handles = update_panels(handles);
% 
% % Update handles structure
% guidata(hObject, handles);

handles = define_panels(handles);
show_panels(handles);

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function txt_noise_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_noise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on slider movement.
function slider5_Callback(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider6_Callback(hObject, eventdata, handles)
% hObject    handle to slider6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in num_con_box.
function num_con_box_Callback(hObject, eventdata, handles)
% hObject    handle to num_con_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns num_con_box contents as cell array
%        contents{get(hObject,'Value')} returns selected item from num_con_box

   contents = cellstr(get(hObject,'String'));
   handles.my_numcon = str2num(contents{get(hObject,'Value')});
   
   try
       G = find_largest_conn(handles.my_Adj_Graph,handles.my_g2m,handles.my_n,handles.my_m,handles.my_numcon);

       axes(handles.axes6);
       spy(G);
   catch
   end
   
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function num_con_box_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_con_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --------------------------------------------------------------------
function uipushtool2_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to uipushtool2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function txt_delta_Callback(hObject, eventdata, handles)
% hObject    handle to txt_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_delta as text
%        str2double(get(hObject,'String')) returns contents of txt_delta as a double

handles.my_delta = str2num(get(handles.txt_delta,'string'));

handles = update_panels(handles);

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function txt_delta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txt_panels_Callback(hObject, eventdata, handles)
% hObject    handle to txt_panels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_panels as text
%        str2double(get(hObject,'String')) returns contents of txt_panels as a double

% handles.my_p = str2num(get(handles.txt_panels,'string'));
% 
% handles = update_panels(handles);
% 
% % Update handles structure
% guidata(hObject, handles);

handles = define_panels(handles);
show_panels(handles);

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function txt_panels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_panels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txt_n_Callback(hObject, eventdata, handles)
% hObject    handle to txt_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_n as text
%        str2double(get(hObject,'String')) returns contents of txt_n as a double

all_settings = handles.all_settings;
model = all_settings.model;
estimation = all_settings.estimation;
weights = all_settings.weights;
results = all_settings.results;

%% RECREATE THE CHANGE-SET
    contents = cellstr(get(handles.popupmenu2,'String'));
    model.selected_val = contents{get(handles.popupmenu2,'Value')};
    model.my_n = str2num(get(handles.txt_n,'string'));
    model.my_m = str2num(get(handles.txt_m,'string'));

    switch model.selected_val
        case 'rectangle'
            model.my_shape = get_shape(model.my_n,model.my_m, model.selected_val);
        case 'diamond'
            model.my_shape = get_shape(model.my_n,model.my_m, model.selected_val);
        case 'round'
            model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
        case 'roundcorner'
            model.my_shape = get_shape(model.my_n, model.my_m,  model.selected_val);
        otherwise
    end

    all_settings.model = model;
    
    handles.all_settings = all_settings;

    % DISPLAY THE CHANGE SET
    axes(handles.axes2);
    imagesc(model.my_shape);
    set(gca,'YDir','normal')
   
    
handles = define_panels(handles);
show_panels(handles);

% Update handles structure
guidata(hObject, handles);



% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function txt_n_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txt_m_Callback(hObject, eventdata, handles)
% hObject    handle to txt_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_m as text
%        str2double(get(hObject,'String')) returns contents of txt_m as a double

all_settings = handles.all_settings;
model = all_settings.model;
estimation = all_settings.estimation;
weights = all_settings.weights;
results = all_settings.results;

%% RECREATE THE CHANGE-SET
    contents = cellstr(get(handles.popupmenu2,'String'));
    model.selected_val = contents{get(handles.popupmenu2,'Value')};
    model.my_n = str2num(get(handles.txt_n,'string'));
    model.my_m = str2num(get(handles.txt_m,'string'));

    switch model.selected_val
        case 'rectangle'
            model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
        case 'diamond'
            model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
        case 'round'
            model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
        case 'roundcorner'
            model.my_shape = get_shape(model.my_n, model.my_m, model.selected_val);
        otherwise
    end

    all_settings.model = model;
    handles.all_settings = all_settings;

    % DISPLAY THE CHANGE SET
    axes(handles.axes2);
    imagesc(model.my_shape);
    set(gca,'YDir','normal')
    
    

handles = define_panels(handles);
show_panels(handles);


% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function txt_m_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_panels_Callback(hObject, eventdata, handles)
% hObject    handle to slider_panels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

axes(handles.axes4);

Ix = get(hObject,'Value');
handles.k = round(max([Ix*handles.all_settings.model.my_p,1]));
show_panels(handles);

% --- Executes during object creation, after setting all properties.
function slider_panels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_panels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function txt_K_Callback(hObject, eventdata, handles)
% hObject    handle to txt_K (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_K as text
%        str2double(get(hObject,'String')) returns contents of txt_K as a double


% --- Executes during object creation, after setting all properties.
function txt_K_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_K (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function txt_gamma_Callback(hObject, eventdata, handles)
% hObject    handle to txt_gamma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_gamma as text
%        str2double(get(hObject,'String')) returns contents of txt_gamma as a double


% --- Executes during object creation, after setting all properties.
function txt_gamma_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_gamma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in toggle_filter1.
function toggle_filter1_Callback(hObject, eventdata, handles)
% hObject    handle to toggle_filter1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of toggle_filter1


% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2



function txt_Q_Callback(hObject, eventdata, handles)
% hObject    handle to txt_Q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_Q as text
%        str2double(get(hObject,'String')) returns contents of txt_Q as a double


% --- Executes during object creation, after setting all properties.
function txt_Q_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_Q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btn_overlapping.
function btn_overlapping_Callback(hObject, eventdata, handles)
% hObject    handle to btn_overlapping (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of btn_overlapping


% --- Executes on button press in chk_connectivity.
function chk_connectivity_Callback(hObject, eventdata, handles)
% hObject    handle to chk_connectivity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of chk_connectivity


% --- Executes on button press in btn_update.
function btn_update_Callback(hObject, eventdata, handles)
% hObject    handle to btn_update (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = define_panels(handles);
show_panels(handles);


% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function btn_update_CreateFcn(hObject, eventdata, handles)
% hObject    handle to btn_update (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in rbtn_critical.
function rbtn_critical_Callback(hObject, eventdata, handles)
% hObject    handle to rbtn_critical (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rbtn_critical

try
    jaccard_distance(handles, handles.all_settings)
catch
    
end


% --- Executes on button press in rbtn_estimate.
function rbtn_estimate_Callback(hObject, eventdata, handles)
% hObject    handle to rbtn_estimate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rbtn_estimate
try
    jaccard_distance(handles, handles.all_settings)
catch
    
end