% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [G] = find_largest_conn(Adj_Graph,g2m,n,m,nconn)


   fprintf('computing connected subsets')
   nm = n*m;
   D =  diag(ones(nm,1));
   Adj_Graph = logical(Adj_Graph + D); 
   sparse_Graph = sparse(Adj_Graph);
   
   [Gp,Gq,Gr,Gs] = dmperm(sparse_Graph);
 
   ms = 0;
   lgr = length(Gr);
   
   ms_matrix = zeros(lgr-1,1);
   
   for c = 1:(lgr-1)
        MS = Gp(Gr(c):Gr(c+1)-1);
        ms_matrix(c,1)=length(MS);
        
        if length(MS)>ms
            ms = length(MS);
            argmax_c = c;
        end
        
   end
   
   [ms_descend,Isort] = sort(ms_matrix,'descend');
   
   G = zeros(n,m);
   
   num_conn_set = nconn;
   for ks=1:num_conn_set
       argmax_c = Isort(ks);  
       lcomp = Gp(Gr(argmax_c):Gr(argmax_c+1)-1);
       G = G + set2graph(lcomp,g2m,n,m); 
   end
   display('...done')
   
end

