% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [all_settings] = get_defaults(p,gamma)
% length of time series

% dimension of observations
model.my_n = 100; 
model.my_m = 100;

% length of time series
model.my_p =  p;%200;

% set change set
model.selected_val = 1; % rectangle set
model.shape_type = 'rectangle';

model.my_shape = get_shape(model.my_n, model.shape_type);

% change and noise size
model.my_delta = 1;
model.my_sigma2 = 2;

% 3-dimensional array for simulations
model.my_P = zeros(model.my_n,model.my_m,model.my_p);

% type of estimator
simulation.est_type = 'emosum';
estimation.est = @E_MOSUM;


estimation.K = 4;
estimation.Q = 1;
estimation.log_direction = 3; %1 horizontal scanning

weights.gamma = gamma;

hvec = 1:(estimation.K-1);                  % auxiliary array 
weights.standard = power((hvec/estimation.K).*(1-hvec/estimation.K),-1); %standard weightining; (this is already divided by sigma2.)

if weights.gamma==0
    weights.weighted = weights.standard*0+1;
else
    weights.weighted = power((hvec/estimation.K).*(1-hvec/estimation.K),-(2*weights.gamma));
end

results.CHANGE_MAT_vertical = zeros(model.my_n,model.my_m);
results.CHANGE_MAT_horizontal = zeros(model.my_n,model.my_m);

model.M_slice_h = zeros(model.my_m,model.my_p); 
model.M_slice_v = zeros(model.my_n,model.my_p);

all_settings.do_filling = 1;

all_settings.model = model;
all_settings.estimation = estimation;
all_settings.weights = weights;
all_settings.results = results;


end

