% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [SP] = get_shape(n,m, shape_type)

[rr cc] = meshgrid(1:m,1:n);

    switch shape_type

        case 'rectangle' % corresponds to max-norm
            p = 1000;
            SPC = abs(rr-floor(m/2))<=min(n,m)/3 & abs(cc-floor(n/2))<=min(n,m)/3;
           
        case 'diamond' % corresponds to l1-norm
            p = 1;
            SPC = power((abs(rr-floor(m/2))).^p + (abs(cc-floor(n/2))).^p,1/p)<=min(n,m)/3;

        case 'round' % corresponds to l2-norm
            p = 2;
            SPC = power((abs(rr-floor(m/2))).^p + (abs(cc-floor(n/2))).^p,1/p)<=min(n,m)/3;

        case 'roundcorner'
            p = 5;
            SPC = power((abs(rr-floor(m/2))).^p + (abs(cc-floor(n/2))).^p,1/p)<=min(n,m)/3;

        otherwise
            error('get_shape(): shape_type not specified')
    end

SP = SPC;

end

