% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [all_settings] = jaccard_distance(handles, all_settings)


model = all_settings.model;
estimation = all_settings.estimation;
weights = all_settings.weights;
results = all_settings.results;


% XX = model.my_P(1:end,1:end,1)/model.my_p;
% for i=2:model.my_p
%     XX = XX + model.my_P(1:end,1:end,i)/model.my_p;
% end

%figure
%imagesc(XX)
%set(gca,'YDir','normal')
%colormap gray

B = model.my_P(1:end,1:end,1)*0;
C = model.my_P(1:end,1:end,1)*0;

CHH = all_settings.results.CHH;
CHV = all_settings.results.CHV;

if get(handles.rbtn_estimate,'Value')
    all_settings.do_filling = 1;
else
    all_settings.do_filling =0;
end

if all_settings.do_filling
   for i=1:model.my_n
        for j=1:model.my_m
            if CHH(i,j)>0                     
                I = find(logical(CHH(i,:)));
                if length(I)>1
                   B(i,(min(I)+1):max(I)) = ones(1,max(I)-min(I));
                end
            end
        end
   end
   
    for j=1:model.my_m
        for i=1:model.my_n
            if CHV(i,j)>0                     
                I = find(logical(CHV(:,j)));
                if length(I)>1
                   C((min(I)+1):max(I),j) = ones(max(I)-min(I),1);
                end
            end
        end
    end  
else
    B = CHH;
    C = CHV;
end
    
Btotal = logical(B+C);
axes(handles.axes1);

MATtotal = B*2+C;
maximal=max(max(MATtotal));

%figure
imagesc(-MATtotal/maximal+1);



A = model.my_shape;

union_set = sum(sum(logical(Btotal+A)));
symmetric_diff_set= sum(sum(logical(Btotal-A)));


set(gca,'YDir','normal')
colormap gray

Jaccard_Distance = symmetric_diff_set/union_set;
   
all_settings.results.jaccard_vh = Jaccard_Distance;

A = model.my_shape;

union_set = sum(sum(logical(B+A)));
symmetric_diff_set= sum(sum(logical(B-A)));

Jaccard_Distance = symmetric_diff_set/union_set;
all_settings.results.jaccard_h = Jaccard_Distance;
all_settings.results.changes_filled = Btotal;
all_settings.results.CHH = CHH;
all_settings.results.CHV = CHV;
end

