% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [all_settings] = make_graph(all_settings)

    model = all_settings.model;
    estimation = all_settings.estimation;
    weights = all_settings.weights;
    results = all_settings.results;
    
    A = results.changes_filled;
    m = model.my_m;
    n = model.my_n;
    
    [m2g,g2m] = matrix2graph(A,m,n);
    adj = zeros(n*m,n*m);
    
    for i=1:(n*m)
        ind = g2m(i,1:2);
   
            if A(ind(1),ind(2)) ~=0 
                
                M_nbr(1,1:2) = ind + [0,1];
                M_nbr(2,1:2) = ind + [0,-1];
                M_nbr(3,1:2) = ind + [1,0];
                M_nbr(4,1:2) = ind + [-1,0];
                M_nbr(5,1:2) = ind + [1,1];
                M_nbr(6,1:2) = ind + [1,-1];
                M_nbr(7,1:2) = ind + [-1,1];
                M_nbr(8,1:2) = ind + [-1,-1];
                 
                for k=1:8 
                    nbr = M_nbr(k,1:2);
                    
                        if check_neighbour(A,nbr)==1
                            I1 = m2g(nbr(1),nbr(2));
                            adj(i,I1) = 1;
                            adj(I1,i) = 1;
                        end
                end
            end
    end
    
    all_settings.estimation.my_g2m = g2m;
    all_settings.estimation.my_m2g = m2g;
    all_settings.estimation.my_Adj_Graph = adj;
end

function [m2g,g2m] = matrix2graph(A,m,n) 
    %A(i,j)= i*(m-1) + j
    
    m2g = A*0;
    g2m = zeros(m*n,2);
    
    for i=1:n
        for j=1:m
            val1 = (i-1)*m + j;
            m2g(i,j)=val1;
            g2m(val1,1:2)=[i,j];
        end
    end
end

function [val] = check_neighbour(A,nbr)
    try
        if A(nbr(1),nbr(2))~=0
            val = 1;
        else
            val = 0;
        end
    catch
        val = 0;
    end
end

