% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [all_settings] = overlapping(all_settings)
% OVERLAPPING (N,Q) - RULE

model = all_settings.model;
estimation = all_settings.estimation;
weights = all_settings.weights;
results = all_settings.results;
 
    A = model.A;
    A_sz = size(A);
    n = A_sz(1); % n is the length of current horizonal/vertical slice
    N = estimation.N; % length of sub-slices
    Q = estimation.Q; % number of overlappings to be considered: default is 1; Q=0 shows all aggregated locations 
    
    acc = [1:n]*0;
       
    controllist = [1:((n-N)+1)]*0; 
    
    for s = 1:(n-N+1)
        A_window = A(s:(s+N-1),:);
        cloc = f_cusum(A_window, weights);
        acc(s) = s-1+cloc; % estimated change point location when scanning {s,...,s+N-1}
    end
 
    for s = 1:(n-Q)
        icc = 0;
        for w=0:Q
            if acc(s+w) == acc(s)
                icc=icc+1;
            end 
        end
        
    
        if icc == (Q+1)
            controllist(s)=acc(s);
        end
    end
    
    u_change_list = unique(controllist);
    
    est_changes = u_change_list(2:end);
    
    all_settings.results.change_set = est_changes;
end