% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [all_settings] = scan_area_gui(all_settings)

model = all_settings.model;
estimation = all_settings.estimation;
weights = all_settings.weights;
results = all_settings.results;
simulation = all_settings.simulation;


    try
        params = varargin{1};
    catch
        display('set some default parameters');
    end
    
    % select estimator
    switch simulation.est_type

       case 'midpoint'
          estimation.est = @midpoint;
                         
       case 'overlapping'
          estimation.est = @overlapping;
         
       otherwise
          stop();

    end
    
    hvec = 1:(estimation.N-1); 
    weights.weighted = power((hvec/estimation.N).*(1-hvec/estimation.N),-(2*weights.gamma));

    results.CHANGE_MAT_vertical = zeros(model.my_n,model.my_m);
    results.CHANGE_MAT_horizontal = zeros(model.my_n,model.my_m);

    model.M_slice_h = zeros(model.my_m,model.my_p); 
    model.M_slice_v = zeros(model.my_n,model.my_p);
   
    display('begin scanning')
  
    switch estimation.direction
        case 'H' 
                estimation.log_direction = 1;
        case 'V' 
                estimation.log_direction = 2;
        case 'VH' 
                estimation.log_direction = 3;
    end
  
   all_settings.model = model;
   all_settings.estimation = estimation;
   all_settings.weights = weights;
   all_settings.results = results;

   all_settings = scanning_ts(all_settings)
   
   

end

