% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [handles] = scan_panels(handles,direction)

    
        all_settings = handles.all_settings;
        model = all_settings.model;
        estimation = all_settings.estimation;
        weights = all_settings.weights;
        results = all_settings.results;

        estimation.N = str2num(get(handles.txt_K,'string'));
        estimation.Q = str2num(get(handles.txt_Q,'string'));
        weights.gamma = str2num(get(handles.txt_gamma,'string'));
        

         simulation.est_type = 'overlapping';
        
        estimation.direction = direction;
        
        estimation.my_numcon = get(handles.num_con_box,'Value');

        
        all_settings.model = model;
        all_settings.estimation = estimation;
        all_settings.weights = weights;
        all_settings.simulation = simulation;
        all_settings = scan_area_gui(all_settings);
        
        CHH = all_settings.results.CHH;
        CHV = all_settings.results.CHV;
        
        all_settings.results.changes = all_settings.results.CHH + all_settings.results.CHV; 
        all_settings = jaccard_distance(handles, all_settings);
            
        if get(handles.chk_connectivity,'Value')
            changes = filter_graph(CHH,CHV);
        else
            changes = CHH + CHV;
        end
        
        axes(handles.axes1);
        maxnoise = max(max(model.my_P(1:end,1:end,1)));
        minnoise = min(min(model.my_P(1:end,1:end,1)));
        maxchange = max(max(changes));

        z = (abs(minnoise)+model.my_P(1:end,1:end,1))/(maxnoise+abs(minnoise));
        cz = z*0;
        
        SZ = size(model.my_P);
        nSZ = SZ(1);
        mSZ = SZ(2);
        
        B = cz*0;
        
        for i=1:nSZ
            for j=1:mSZ
                if changes(i,j)>0
                    cz(i,j) = 1+ changes(i,j)/maxchange;
                    z(i,j) = 0;
                    
                    I = find(logical(changes(i,:)));
                    if length(I)>1
                       B(i,(I(1)+1):I(2)) = ones(1,I(2)-I(1));
                    end
                end
            end
        end
        
        all_settings.model = model;
        all_settings.estimation = estimation;
        all_settings.weights = weights;
        
        all_settings.results.changes = changes;
        
        all_settings.do_filling = 1;
        all_settings = jaccard_distance(handles, all_settings);
        handles.all_settings = all_settings;
        
         
   if get(handles.chk_connectivity, 'Value')
        merge_z_cz= z+cz;
        merge_z_cz(end,end)=2;
    

   [all_settings] = make_graph(all_settings);

       model = all_settings.model;
       estimation = all_settings.estimation;
       weights = all_settings.weights;
       results = all_settings.results;
        
       g2mR = estimation.my_g2m;
       g2mR(1:end,2) = -estimation.my_g2m(1:end,1)+model.my_n;
       g2mR(1:end,1) = estimation.my_g2m(1:end,2);

       axes(handles.axes3);
       gplot(estimation.my_Adj_Graph, g2mR); 
       set(gca,'YDir','normal');
       colormap gray


       contents = cellstr(get(handles.num_con_box,'String'));
       estimation.my_numcon = str2num(contents{get(handles.num_con_box,'Value')});

       G = find_largest_conn(estimation.my_Adj_Graph,estimation.my_g2m,model.my_n,model.my_m,estimation.my_numcon);

       all_settings.results.CHH = G;
       all_settings.results.CHV = G;
       all_settings.estimation.my_numcon = estimation.my_numcon;
       

       axes(handles.axes6);
       spy(G);
       set(gca,'YDir','normal');
       colormap gray
   end
end

