% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved.

function [all_settings] = scanning_ts(all_settings)

model = all_settings.model;
estimation = all_settings.estimation;
weights = all_settings.weights;
results = all_settings.results;

   if estimation.log_direction == 1 || estimation.log_direction == 3 
       wbar = waitbar(0,'scanning horizonally');
       
       for i=1:model.my_n
           model.M_slice_h(1:end,1:end) = model.my_P(i,:,:);
           model.A = model.M_slice_h;
           
            all_settings.model = model;
            all_settings.estimation = estimation;
            all_settings.weights = weights;
            all_settings.results = results;
            
            
            all_settings = estimation.est(all_settings);
            

            results = all_settings.results;
            
           for location = results.change_set
               results.CHANGE_MAT_horizontal(i,location) = 20;
           end
           waitbar(i/model.my_n);
       end
       close(wbar);
   end
   
   if estimation.log_direction == 2 || estimation.log_direction == 3  
       wbar = waitbar(0,'scanning vertically');
       for j=1:model.my_m
           model.M_slice_v(1:end,1:end) = model.my_P(:,j,:);
           model.A = model.M_slice_v;
           
            all_settings.model = model;
            all_settings.estimation = estimation;
            all_settings.weights = weights;
            all_settings.results = results;
           
            all_settings = estimation.est(all_settings);

            results = all_settings.results;

           for location = results.change_set
               results.CHANGE_MAT_vertical(location,j) = 20;
           end
           waitbar(j/model.my_m);
       end
       close(wbar);
   end
   
   results.CHH = results.CHANGE_MAT_horizontal;
   results.CHV = results.CHANGE_MAT_vertical; 
   
all_settings.model = model;
all_settings.estimation = estimation;
all_settings.weights = weights;
all_settings.results = results;
end

